from pybind11.setup_helpers import Pybind11Extension, build_ext
from pybind11 import get_cmake_dir
import pybind11
from setuptools import setup, Extension
import glob

__version__ = "0.1.0"

# The main interface is through Pybind11Extension.
ext_modules = [
    Pybind11Extension(
        "garch11_ged",
        [
            "src/garch11_ged.cpp",
            "src/python_bindings.cpp",
        ],
        include_dirs=[
            "include",
            # Path to pybind11 headers
            pybind11.get_include(),
        ],
        language='c++',
        cxx_std=14,
    ),
]

setup(
    name="garch11_ged",
    version=__version__,
    author="Your Name",
    author_email="your.email@example.com", 
    url="https://github.com/yourusername/garch11_ged",
    description="Fast GARCH(1,1) with GED innovations implementation in C++",
    long_description=open("README.md").read(),
    long_description_content_type="text/markdown",
    ext_modules=ext_modules,
    extras_require={"test": "pytest"},
    cmdclass={"build_ext": build_ext},
    zip_safe=False,
    python_requires=">=3.6",
    classifiers=[
        "Development Status :: 4 - Beta",
        "Intended Audience :: Financial and Insurance Industry",
        "Intended Audience :: Science/Research",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.6",
        "Programming Language :: Python :: 3.7",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Programming Language :: C++",
        "Topic :: Scientific/Engineering :: Mathematics",
        "Topic :: Office/Business :: Financial",
    ],
    keywords="garch volatility financial-modeling time-series econometrics",
    install_requires=[
        "numpy>=1.15.0",
    ],
) 